//+------------------------------------------------------------------+
//|                                        Moving Average_odify.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                      Modify  by BARS             |
//+------------------------------------------------------------------+
#define MAGICMA  20050610
//-----------------------------------------
extern int      StopLoss=0;
extern int      TakeProfit=0;
extern double   Lots               = 0.5;
extern double   MaximumRisk        = 0.03;
extern double   DecreaseFactor     = 1;
extern double   MovingPeriod_Open  = 6;
extern double   MovingPeriod_Close = 34;
extern double   MovingShift        = 0;

double SL,TP;
//--   --
#include <stderror.mqh>
#include <stdlib.mqh>
//+
void start()  {
//---- check for history and trading
//(     100     )
   if(Bars<100 || IsTradeAllowed()==false) return;
  //---- calculate open orders by current symbol
//       
   if(CalculateCurrentOrders(Symbol())==0)
   CheckForOpen();//  
   else     CheckForClose();//  , -  
             
              }
              
    //    void start()+             
//   +
//|                          |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)  {
   int buys=0,sells=0; for(int i=0;i<OrdersTotal();i++)
                       {
   if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++; }
                                           }
//---- return orders volume
   if(buys>0) return(buys);   else       return(-sells);
                                           }
//+
//|                             |
//+------------------------------------------------------------------+
double LotsOptimized()  {
   double lot=Lots;
   int    orders=HistoryTotal();   // history orders total
   int    losses=0;         // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)               {
      for(int i=orders-1;i>=0;i--)     {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false)
          { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//---- return lot size
   if(lot<0.5) lot=0.5;
   return(lot);
  }
//    +
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()  {
   double ma;   int    res;
//---- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
//---- get Moving Average 
   ma=iMA(NULL,0,MovingPeriod_Open,MovingShift,MODE_SMA,PRICE_CLOSE,0);
//---- sell conditions
   if(Open[1]>ma && Close[1]<ma)  {
   SL=0;TP=0;
   if(StopLoss>0)   SL=Bid+Point*StopLoss;
   if(TakeProfit>0) TP=Bid-Point*TakeProfit;   
   res=WHCOrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,3,SL,TP,
                                         "Moving Average",MAGICMA,0,Red);
   if(res < 0){Print("   SELL #", GetLastError()); 
                Sleep(10000);   return (0);  }
     }
//---- buy conditions
   if(Open[1]<ma && Close[1]>ma){
   SL=0;TP=0;
   if(StopLoss>0)   SL=Ask-Point*StopLoss;
   if(TakeProfit>0) TP=Ask+Point*TakeProfit;   
   res=WHCOrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,SL,TP,
                                       "Moving Average",MAGICMA,0,Blue);
   if(res < 0) { Print("   BUY #", GetLastError()); 
               Sleep(10000);   return (0); }
        }
//----
  
  }
    
  
//++
//                                            |
//+------------------------------------------------------------------+
void CheckForClose()  {
   double ma;
//---- go trading only for first tiks of new bar
//(      )
   if(Volume[0]>1) return;
//---- get Moving Average 
   ma=iMA(NULL,0,MovingPeriod_Close,MovingShift,MODE_SMA,PRICE_CLOSE,0);
//----
   for(int i=0;i<OrdersTotal();i++)     {
    if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY)        {
         if(Open[1]>ma && Close[1]<ma) 
         OrderClose(OrderTicket(),OrderLots(),Bid,3,White);     break;
                                     }
      if(OrderType()==OP_SELL)       {
         if(Open[1]<ma && Close[1]>ma) 
         OrderClose(OrderTicket(),OrderLots(),Ask,3,White);     break;
                                     }
                                        }
//---------------------
                                         }
                           
                                                  
//+
//        
//   Market Watch
int WHCOrderSend(string symbol,   int cmd,     double volume,
                 double price, int slippage, double stoploss, 
                 double takeprofit, string comment,int magic, 
                 datetime expiration,      color arrow_color)
{  int ticket =  OrderSend(symbol,cmd,               volume, price, slippage, 0, 0,
   comment, magic,                                        expiration, arrow_color);   
   int check = -1;   if (ticket > 0 && (stoploss != 0 || takeprofit != 0))        {
   if (!OrderModify(ticket, price, stoploss, takeprofit,expiration, arrow_color)) {
   check = GetLastError();                             if (check != ERR_NO_ERROR) {
   Print("OrderModify error: ", ErrorDescription(check)); } }              } else {
   check = GetLastError();                              if (check != ERR_NO_ERROR){
   Print("OrderSend error: ",ErrorDescription(check));  } }   return (ticket);    }
//+

